# Fee Example Code

## Project Name: Fee

---

## Function description

This project is designed to demonstrate the FEE module config and usage:
- **Fee**: 
  - Print reset count which save in the fee.
  - Test write, read and check fee block data.

---

## HW requirement
+ **EVB**: YTM32B1LE0-EVB-Q64
+ **Debugger**: J-LINK v9.2 or later with YUNTU YTM32B1LE0 patch(support package) installed.

---

## SW requirement

+ **Config & Code Generation Tool**
  + **SDK**:       Yuntu Config Tool(YCT) v2.6.3 or later version
+ **Compiler Toolchain**
  + **GCC***     : GNU GCC v10.3 or later version
  + **Keil/MDK***: ARM Keil/MDK v5.36 or later version
  + **IAR***     : IAR v8.4 or later version
  + **VS Code**  : Microsoft Visual Studio Code IDE v1.76 or later version(C/C++ support, GNU toolchain, CMake v3.25, ninja, Cortex-Debug extensions installation required)
+ **Debugger driver**
    + **J-LINK***              : SEGGER JLINK v6.96 or later version, YUNTU YTM32B1MD1 patch(support package) installation required.
    + **Ozone Debugger tool**  : SEGGER Ozone v3.28 or later version.

    ***Note***: * **YTM32B1MD1** patch install required which can be obtained via **YCT** or contact ***YUNTU sales/FAE team***.

---

## Setup

+ ***Step1***: Open the project.yct with the YCT tool, config the toolchain per your required(by default, the VS code + GCC are used)
+ ***Step2***: Generate the codes, you can change the configurations if needed(to adapt to your own HW design), if so, please ensure all the modifications are OK with no any errors exist before generating the code.
+ ***Step3***: Open the generated project with VS code/IAR/Keil IDE per your selected.
+ ***Step4***: Compile the project, power on the EVB and download it to the EVB via the available debugger, such as a J-LINK debugger probe.
+ ***Step5***: At last, enjoy the demo example.
  
---

1. Config alt value of PTC_9 Pin with Uart1_TX as TX pin and PTC_8 with Uart1_RX as RX pin.
2. Enable and config Uart1_CLK.
3. Enable and config Uart and Utility Print module.
4. Enable and config Fee module.
5. Erase the chip, then download the firmware to the chip.
6. Each reset will print the number of reset count which recorded in the fee.
7. It will be printed if data check is uncorrectly or fee job is unsuccessful.

---