/* USER CODE BEGIN Header */
/* you can remove the copyright */

/*
 *  Copyright 2020-2023 Yuntu Microelectronics co.,ltd
 *  All rights reserved.
 * 
 *  YUNTU Confidential. This software is owned or controlled by YUNTU and may only be
 *  used strictly in accordance with the applicable license terms. By expressly
 *  accepting such terms or by downloading, installing, activating and/or otherwise
 *  using the software, you are agreeing that you have read, and that you agree to
 *  comply with and are bound by, such license terms. If you do not agree to be
 *  bound by the applicable license terms, then you may not retain, install,
 *  activate or otherwise use the software. The production use license in
 *  Section 2.3 is expressly granted for this software.
 * 
 * @file main.c
 * @brief 
 * 
 */

/* USER CODE END Header */
#include "sdk_project_config.h"
/* Includes ------------------------------------------------------------------*/

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */
/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
#define TEST_COUNT 10
#define FEE_WAIT_DONE()     \
    do                      \
    {                       \
        Fee_MainFunction(); \
    } while (MEMIF_IDLE != Fee_GetStatus());
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */
/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/
/* USER CODE BEGIN PV */
volatile uint32_t Task1msCnt = 0;

uint32_t PowerUpCnt = 0;
uint32_t DataWriteCnt = 0;
uint8_t ReadDataBuffer[50] = { 0xFF, 0xFF, 0xFF, 0xFF };
uint8_t WriteDataBuffer[50] = { 0x00 };
/* USER CODE END PV */

/* Private function declare --------------------------------------------------*/
/* USER CODE BEGIN PFDC */
/* USER CODE END PFDC */
static void Board_Init(void);

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */
/* USER CODE END 0 */


/**
 * @brief  The application entry point.
 * @retval int
 */
int main(void)
{
    /* USER CODE BEGIN 1 */
    status_t status = STATUS_SUCCESS;

    /* USER CODE END 1 */ 
    Board_Init();
    /* USER CODE BEGIN 2 */
    PRINTF("Build %s %s\n", __DATE__, __TIME__);
    PRINTF("Fee demo!\r\n");
    PRINTF("For YTM32B1LE0, FEE doesnot support Async Access, even if stored in DFlash!!!\r\n");

    Fee_Init(&FEEGenConfig);
    FEE_WAIT_DONE();

    if (MEMIF_JOB_OK != Fee_GetJobResult())
    {
        PRINTF("The Fee initialization is failed, job status is %d\r\n", Fee_GetJobResult());
    }
    else
    {
        PRINTF("The Fee initialization is successful.\r\n");
    }

    /* Read PowerUpCnt from PowerUpCnt_Block */
    Fee_Read(PowerUpCnt_Block, 0, (uint8_t *)&PowerUpCnt, 4);
    FEE_WAIT_DONE();

    if (MEMIF_JOB_FAILED == Fee_GetJobResult())
    {
        /* PowerUpCnt_Block never been written */
        /* Also not set PowerUpCnt to 0, because PowerUpCnt would not be changed if job failed */
        PowerUpCnt = 0;
    }
    PowerUpCnt++;
    PRINTF("It's %d times to power up!\r\n", PowerUpCnt);

    /* Write PowerUpCnt back to PowerUpCnt_Block */
    Fee_Write(PowerUpCnt_Block, (uint8_t *)&PowerUpCnt);
    /*Perform write data to Block 0*/
    FEE_WAIT_DONE();

    if (MEMIF_JOB_OK != Fee_GetJobResult())
    {
        PRINTF("The PowerUpCnt_Block write error!\r\n");
    }
    /* USER CODE END 2 */

    /* Infinite loop */
    /* USER CODE BEGIN WHILE */
    for (int i = 0; i < TEST_COUNT; i++)
    {
        DataWriteCnt++;
        for (int i = 0; i < 50; i++)
        {
            WriteDataBuffer[i] = (uint8_t)(DataWriteCnt + i);
        }
        Fee_Write(DataSave_Block, WriteDataBuffer);
        FEE_WAIT_DONE();
        if (MEMIF_JOB_OK != Fee_GetJobResult())
        {
            PRINTF("The DataSave_Block write error!\r\n");
        }

        Fee_Read(DataSave_Block, 0, ReadDataBuffer, 50);
        FEE_WAIT_DONE();
        if (MEMIF_JOB_OK != Fee_GetJobResult())
        {
            PRINTF("The DataSave_Block read error!\r\n");
        }

        /* Check data with WriteDataBuffer */
        for (int i = 0; i < 50; i++)
        {
            if (WriteDataBuffer[i] != ReadDataBuffer[i])
            {
                PRINTF("The DataSave_Block check error!\r\n");
                break;
            }
        }

        /* USER CODE END WHILE */
        /* USER CODE BEGIN 3 */
        if (status != STATUS_SUCCESS)
        {
            break;
        }
    }
    PRINTF("The Fee Demo End!\r\n");
    /* USER CODE END 3 */
}

static void Board_Init(void)
{
    CLOCK_SYS_Init(g_clockManConfigsArr,CLOCK_MANAGER_CONFIG_CNT,g_clockManCallbacksArr,CLOCK_MANAGER_CALLBACK_CNT);
    CLOCK_SYS_UpdateConfiguration(CLOCK_MANAGER_ACTIVE_INDEX,CLOCK_MANAGER_POLICY_AGREEMENT);
    PINS_DRV_Init(NUM_OF_CONFIGURED_PINS0,g_pin_mux_InitConfigArr0);
    UTILITY_PRINT_Init();
}

/* USER CODE BEGIN 4 */
/* USER CODE END 4 */
