/*
 *  Copyright 2020-2024 Yuntu Microelectronics co.,ltd
 *  All rights reserved.
 * 
 *  YUNTU Confidential. This software is owned or controlled by YUNTU and may only be
 *  used strictly in accordance with the applicable license terms. By expressly
 *  accepting such terms or by downloading, installing, activating and/or otherwise
 *  using the software, you are agreeing that you have read, and that you agree to
 *  comply with and are bound by, such license terms. If you do not agree to be
 *  bound by the applicable license terms, then you may not retain, install,
 *  activate or otherwise use the software. The production use license in
 *  Section 2.3 is expressly granted for this software.
 * 
 * @file fee_config.h
 * @brief 
 * 
 */




#ifndef __FEE_CONFIG_H__
#define __FEE_CONFIG_H__



#include "fee.h"

#define FLS_CONFIGURED_SECTOR_NUMBER 8U/*Count of user configuration flash sectors*/
#define FEE_NUMBER_OF_CLUSTER_GROUPS 2U  /* Number of configured Fee cluster group */
#define FEE_CRT_CFG_NR_OF_BLOCKS  3U /* Number of configured Fee blocks */


/* Symbolic names of configured Fee blocks */
#define PowerUpCnt_Block      (1U)
#define DataSave_Block      (2U)
#define ErrorRecord_Block      (3U)




extern const Fee_ModuleUserConfig_t FEEGenConfig;

#endif


